vine_stats Struct Reference

Statistics describing a manager. More...

`#include <taskvine.h>`

## Data Fields

int | workers_connected
| Number of workers currently connected to the manager.
int | workers_init
| Number of workers connected, but that have not send their available resources report yet.
int | workers_idle
| Number of workers that are not running a task.
int | workers_busy
| Number of workers that are running at least one task.
int | workers_able
| Number of workers on which the largest task can run.
int | workers_joined
| Total number of worker connections that were established to the manager.
int | workers_removed
| Total number of worker connections that were terminated.
int | workers_released
| Total number of worker connections that were asked by the manager to disconnect.
int | workers_idled_out
| Total number of worker that disconnected for being idle.
int | workers_slow
| Total number of workers disconnected for being too slow.
int | workers_blocked
| Total number of workers blocked by the manager.
int | workers_lost
| Total number of worker connections that were unexpectedly lost.
int | tasks_waiting
| Number of tasks waiting to be dispatched.
int | tasks_on_workers
| Number of tasks currently dispatched to some worker.
int | tasks_running
| Number of tasks currently executing at some worker.
int | tasks_with_results
| Number of tasks with retrieved results and waiting to be returned to user.
int | tasks_submitted
| Total number of tasks submitted to the manager.
int | tasks_dispatched
| Total number of tasks dispatch to workers.
int | tasks_done
| Total number of tasks completed and returned to user.
int | tasks_failed
| Total number of tasks completed and returned to user with result other than VINE_RESULT_SUCCESS.
int | tasks_cancelled
| Total number of tasks cancelled.
int | tasks_exhausted_attempts
| Total number of task executions that failed given resource exhaustion.
timestamp_t | time_when_started
| Absolute time at which the manager started.
timestamp_t | time_send
| Total time spent in sending tasks to workers (tasks descriptions, and input files.).
timestamp_t | time_receive
| Total time spent in receiving results from workers (output files.).
timestamp_t | time_send_good
| Total time spent in sending data to workers for tasks with result VINE_RESULT_SUCCESS.
timestamp_t | time_receive_good
| Total time spent in sending data to workers for tasks with result VINE_RESULT_SUCCESS.
timestamp_t | time_status_msgs
| Total time spent sending and receiving status messages to and from workers, including workers' standard output, new workers connections, resources updates, etc.
timestamp_t | time_internal
| Total time the manager spents in internal processing.
timestamp_t | time_polling
| Total time blocking waiting for worker communications (i.e., manager idle waiting for a worker message).
timestamp_t | time_application
| Total time spent outside vine_wait.
timestamp_t | time_scheduling
| Total time spend matching tasks to workers.
timestamp_t | time_workers_execute
| Total time workers spent executing done tasks.
timestamp_t | time_workers_execute_good
| Total time workers spent executing done tasks with result VINE_RESULT_SUCCESS.
timestamp_t | time_workers_execute_exhaustion
| Total time workers spent executing tasks that exhausted resources.
int64_t | bytes_sent
| Total number of file bytes (not including protocol control msg bytes) sent out to the workers by the manager.
int64_t | bytes_received
| Total number of file bytes (not including protocol control msg bytes) received from the workers by the manager.
double | bandwidth
| Average network bandwidth in MB/S observed by the manager when transferring to workers.
int | capacity_tasks
| The estimated number of tasks that this manager can effectively support.
int | capacity_cores
| The estimated number of workers' cores that this manager can effectively support.
int | capacity_memory
| The estimated number of workers' MB of RAM that this manager can effectively support.
int | capacity_disk
| The estimated number of workers' MB of disk that this manager can effectively support.
int | capacity_gpus
| The estimated number of workers' GPUs that this manager can effectively support.
int | capacity_instantaneous
| The estimated number of tasks that this manager can support considering only the most recently completed task.
int | capacity_weighted
| The estimated number of tasks that this manager can support placing greater weight on the most recently completed task.
int64_t | total_cores
| Total number of cores aggregated across the connected workers.
int64_t | total_memory
| Total memory in MB aggregated across the connected workers.
int64_t | total_disk
| Total disk space in MB aggregated across the connected workers.
int64_t | total_gpus
| Total number of gpus aggregated across the connected workers.
int64_t | committed_cores
| Committed number of cores aggregated across the connected workers.
int64_t | committed_memory
| Committed memory in MB aggregated across the connected workers.
int64_t | committed_disk
| Committed disk space in MB aggregated across the connected workers.
int64_t | committed_gpus
| Committed number of gpus aggregated across the connected workers.
int64_t | max_cores
| The highest number of cores observed among the connected workers.
int64_t | max_memory
| The largest memory size in MB observed among the connected workers.
int64_t | max_disk
| The largest disk space in MB observed among the connected workers.
int64_t | max_gpus
| The highest number of gpus observed among the connected workers.
int64_t | min_cores
| The lowest number of cores observed among the connected workers.
int64_t | min_memory
| The smallest memory size in MB observed among the connected workers.
int64_t | min_disk
| The smallest disk space in MB observed among the connected workers.
int64_t | min_gpus
| The smallest number of gpus observed among the connected workers.
int64_t | inuse_cache
| Used disk space of declared files in MB aggregated across the connected workers.

## Detailed Description

Statistics describing a manager.

## Field Documentation

## workers_connected

int vine_stats::workers_connected

Number of workers currently connected to the manager.

## workers_init

int vine_stats::workers_init

Number of workers connected, but that have not send their available resources report yet.

## workers_idle

int vine_stats::workers_idle

Number of workers that are not running a task.

## workers_busy

int vine_stats::workers_busy

Number of workers that are running at least one task.

## workers_able

int vine_stats::workers_able

Number of workers on which the largest task can run.

## workers_joined

int vine_stats::workers_joined

Total number of worker connections that were established to the manager.

## workers_removed

int vine_stats::workers_removed

Total number of worker connections that were terminated.

## workers_released

int vine_stats::workers_released

Total number of worker connections that were asked by the manager to disconnect.

## workers_idled_out

int vine_stats::workers_idled_out

Total number of worker that disconnected for being idle.

## workers_slow

int vine_stats::workers_slow

Total number of workers disconnected for being too slow.

(see vine_enable_disconnect_slow_workers)

## workers_blocked

int vine_stats::workers_blocked

Total number of workers blocked by the manager.

(Includes workers_slow.)

## workers_lost

int vine_stats::workers_lost

Total number of worker connections that were unexpectedly lost.

(does not include workers_idle_out or workers_slow)

## tasks_waiting

int vine_stats::tasks_waiting

Number of tasks waiting to be dispatched.

## tasks_on_workers

int vine_stats::tasks_on_workers

Number of tasks currently dispatched to some worker.

## tasks_running

int vine_stats::tasks_running

Number of tasks currently executing at some worker.

## tasks_with_results

int vine_stats::tasks_with_results

Number of tasks with retrieved results and waiting to be returned to user.

## tasks_submitted

int vine_stats::tasks_submitted

Total number of tasks submitted to the manager.

## tasks_dispatched

int vine_stats::tasks_dispatched

Total number of tasks dispatch to workers.

## tasks_done

int vine_stats::tasks_done

Total number of tasks completed and returned to user.

(includes tasks_failed)

## tasks_failed

int vine_stats::tasks_failed

Total number of tasks completed and returned to user with result other than VINE_RESULT_SUCCESS.

## tasks_cancelled

int vine_stats::tasks_cancelled

Total number of tasks cancelled.

## tasks_exhausted_attempts

int vine_stats::tasks_exhausted_attempts

Total number of task executions that failed given resource exhaustion.

## time_when_started

timestamp_t vine_stats::time_when_started

Absolute time at which the manager started.

## time_send

timestamp_t vine_stats::time_send

Total time spent in sending tasks to workers (tasks descriptions, and input files.).

## time_receive

timestamp_t vine_stats::time_receive

Total time spent in receiving results from workers (output files.).

## time_send_good

timestamp_t vine_stats::time_send_good

Total time spent in sending data to workers for tasks with result VINE_RESULT_SUCCESS.

## time_receive_good

timestamp_t vine_stats::time_receive_good

Total time spent in sending data to workers for tasks with result VINE_RESULT_SUCCESS.

## time_status_msgs

timestamp_t vine_stats::time_status_msgs

Total time spent sending and receiving status messages to and from workers, including workers' standard output, new workers connections, resources updates, etc.

## time_internal

timestamp_t vine_stats::time_internal

Total time the manager spents in internal processing.

## time_polling

timestamp_t vine_stats::time_polling

Total time blocking waiting for worker communications (i.e., manager idle waiting for a worker message).

## time_application

timestamp_t vine_stats::time_application

Total time spent outside vine_wait.

## time_scheduling

timestamp_t vine_stats::time_scheduling

Total time spend matching tasks to workers.

## time_workers_execute

timestamp_t vine_stats::time_workers_execute

Total time workers spent executing done tasks.

## time_workers_execute_good

timestamp_t vine_stats::time_workers_execute_good

Total time workers spent executing done tasks with result VINE_RESULT_SUCCESS.

## time_workers_execute_exhaustion

timestamp_t vine_stats::time_workers_execute_exhaustion

Total time workers spent executing tasks that exhausted resources.

## bytes_sent

int64_t vine_stats::bytes_sent

Total number of file bytes (not including protocol control msg bytes) sent out to the workers by the manager.

## bytes_received

int64_t vine_stats::bytes_received

Total number of file bytes (not including protocol control msg bytes) received from the workers by the manager.

## bandwidth

double vine_stats::bandwidth

Average network bandwidth in MB/S observed by the manager when transferring to workers.

## capacity_tasks

int vine_stats::capacity_tasks

The estimated number of tasks that this manager can effectively support.

## capacity_cores

int vine_stats::capacity_cores

The estimated number of workers' cores that this manager can effectively support.

## capacity_memory

int vine_stats::capacity_memory

The estimated number of workers' MB of RAM that this manager can effectively support.

## capacity_disk

int vine_stats::capacity_disk

The estimated number of workers' MB of disk that this manager can effectively support.

## capacity_gpus

int vine_stats::capacity_gpus

The estimated number of workers' GPUs that this manager can effectively support.

## capacity_instantaneous

int vine_stats::capacity_instantaneous

The estimated number of tasks that this manager can support considering only the most recently completed task.

## capacity_weighted

int vine_stats::capacity_weighted

The estimated number of tasks that this manager can support placing greater weight on the most recently completed task.

## total_cores

int64_t vine_stats::total_cores

Total number of cores aggregated across the connected workers.

## total_memory

int64_t vine_stats::total_memory

Total memory in MB aggregated across the connected workers.

## total_disk

int64_t vine_stats::total_disk

Total disk space in MB aggregated across the connected workers.

## total_gpus

int64_t vine_stats::total_gpus

Total number of gpus aggregated across the connected workers.

## committed_cores

int64_t vine_stats::committed_cores

Committed number of cores aggregated across the connected workers.

## committed_memory

int64_t vine_stats::committed_memory

Committed memory in MB aggregated across the connected workers.

## committed_disk

int64_t vine_stats::committed_disk

Committed disk space in MB aggregated across the connected workers.

## committed_gpus

int64_t vine_stats::committed_gpus

Committed number of gpus aggregated across the connected workers.

## max_cores

int64_t vine_stats::max_cores

The highest number of cores observed among the connected workers.

## max_memory

int64_t vine_stats::max_memory

The largest memory size in MB observed among the connected workers.

## max_disk

int64_t vine_stats::max_disk

The largest disk space in MB observed among the connected workers.

## max_gpus

int64_t vine_stats::max_gpus

The highest number of gpus observed among the connected workers.

## min_cores

int64_t vine_stats::min_cores

The lowest number of cores observed among the connected workers.

## min_memory

int64_t vine_stats::min_memory

The smallest memory size in MB observed among the connected workers.

## min_disk

int64_t vine_stats::min_disk

The smallest disk space in MB observed among the connected workers.

## min_gpus

int64_t vine_stats::min_gpus

The smallest number of gpus observed among the connected workers.

## inuse_cache

int64_t vine_stats::inuse_cache

Used disk space of declared files in MB aggregated across the connected workers.

The documentation for this struct was generated from the following file:

- taskvine.h